--[[
Copyright (C) [HoT] Zombold 2022

Author: [HoT] Zombold
Date: 25.04.2022
Version: 1.0.0.0


Important:
No release for foreign mods - script is property of HoT in connection with VisionAqua!
No changes are to be made to this script without permission from [HoT] Zombold.

Keine Freigabe für fremde Mods - Script ist Eigentum von HoT in Verbindung mit VisionAqua!
]]

visionAqua = {};

function visionAqua:onUpdateTick(of, dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	local spec = self.spec_waterTrailer
	local _, y, _ = getWorldTranslation(spec.waterFillNode)
	local isNearWater = y <= self.waterY + 0.2

	if isNearWater then
		g_currentMission.activatableObjectsSystem:addActivatable(spec.activatable)
	else
		g_currentMission.activatableObjectsSystem:removeActivatable(spec.activatable)
	end

	if self.isServer then
		if spec.isFilling and not isNearWater then
			self:setIsWaterTrailerFilling(false)
		end

		if spec.isFilling and self:getFillUnitAllowsFillType(spec.fillUnitIndex, FillType.DIRTYWATER) then
			local delta = self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.fillUnitIndex, spec.fillLitersPerSecond * dt * 0.001, FillType.DIRTYWATER, ToolType.TRIGGER, nil)

			if delta <= 0 then
				self:setIsWaterTrailerFilling(false)
			end
		end
	end
end

function visionAqua:getIsActivatable(of)
	local fillUnitIndex = self.trailer.spec_waterTrailer.fillUnitIndex

	if self.trailer:getIsActiveForInput(true) and self.trailer:getFillUnitFillLevel(fillUnitIndex) < self.trailer:getFillUnitCapacity(fillUnitIndex) and self.trailer:getFillUnitAllowsFillType(fillUnitIndex, FillType.DIRTYWATER) then
		self:updateActivateText()

		return true
	end

	return false
end

WaterTrailer.onUpdateTick = Utils.overwrittenFunction(WaterTrailer.onUpdateTick, visionAqua.onUpdateTick)
WaterTrailerActivatable.getIsActivatable = Utils.overwrittenFunction(WaterTrailerActivatable.getIsActivatable, visionAqua.getIsActivatable)

function visionAqua:addItem(of, storeItem)
	local otherItem = self.xmlFilenameToItem[storeItem.xmlFilenameLower]
	if storeItem.xmlFilename == "data/placeables/lizard/waterTanks/level02/waterTankLevel02.xml" then return false end

	if otherItem ~= nil then
		if otherItem.isBundleItem and not storeItem.isBundleItem then
			otherItem.isBundleItem = storeItem.isBundleItem
			otherItem.showInStore = storeItem.showInStore
		end

		return false
	end

	table.insert(self.items, storeItem)

	storeItem.id = #self.items
	self.xmlFilenameToItem[storeItem.xmlFilenameLower] = storeItem

	return true
end

StoreManager.addItem = Utils.overwrittenFunction(StoreManager.addItem, visionAqua.addItem)